<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:gzl="http://java.sun.com/jsf/composite/gazelle-tags"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <gzl:div id="globalDiv">
                <h1>
                    <h:outputText value="#{fhirURLValidatorDescriptionEdition.validatorDescription.name}"
                                  rendered="#{not empty fhirURLValidatorDescriptionEdition.validatorDescription.name}"/>
                    <h:outputText value="New FHIR Validator Description"
                                  rendered="#{empty fhirURLValidatorDescriptionEdition.validatorDescription.name}"/>
                </h1>
                <gzl:div id ="displayP">
                    <gri:panel>
                        <f:facet name="header">Validation description</f:facet>
                        <gzl:div styleClass="form-horizontal">
                            <ui:include src="/validators/editCommon.xhtml">
                                <ui:param name="managedBean" value="#{fhirURLValidatorDescriptionEdition}"/>
                            </ui:include>
                            <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:define name="label">Name of queried resource</ui:define>
                                <ui:param name="id" value="rscIn"/>
                                <ui:param name="required" value="true"/>
                                <h:inputText id="rscIn" styleClass="form-control"
                                             value="#{fhirURLValidatorDescriptionEdition.validatorDescription.resourceName}"
                                             required="true"/>
                            </ui:decorate>
                            <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                <ui:define name="label">Name of operation</ui:define>
                                <ui:param name="id" value="opIn"/>
                                <h:inputText id="opIn" styleClass="form-control"
                                             value="#{fhirURLValidatorDescriptionEdition.validatorDescription.operation}"/>
                            </ui:decorate>
                        </gzl:div>
                        <gri:panel pid="editParameter" rendered="#{not empty fhirURLValidatorDescriptionEdition.selectedParameter}">
                            <f:facet name="header">Add/Edit parameter</f:facet>
                            <gzl:div styleClass="form-horizontal">
                                <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:define name="label">Name</ui:define>
                                    <ui:param name="id" value="pNameIn"/>
                                    <ui:param name="required" value="true"/>
                                    <h:inputText id="pNameIn" styleClass="form-control"
                                                 value="#{fhirURLValidatorDescriptionEdition.selectedParameter.name}"
                                                 required="true"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:define name="label">Prefix</ui:define>
                                    <ui:param name="id" value="pPrefixIn"/>
                                    <h:selectOneMenu value="#{fhirURLValidatorDescriptionEdition.selectedParameter.prefix}"
                                                     styleClass="form-control  gzl-select-text" id="pPrefixIn">
                                        <f:selectItem itemLabel="#{messages['gazelle.simulator.PleaseSelect']}"
                                                      itemValue="#{null}"/>
                                        <f:selectItems value="#{fhirURLValidatorDescriptionEdition.getPrefixes()}"
                                                       var="entry" label="#{entry.prefixValue}" noSelectionLabel="Please select..."/>
                                    </h:selectOneMenu>
                                </ui:decorate>
                                <ui:decorate template="/layout/form/_checkbox.xhtml">
                                    <h:selectBooleanCheckbox value="#{fhirURLValidatorDescriptionEdition.selectedParameter.required}"/>
                                    <h:outputText value="Parameter is required"/>
                                </ui:decorate>
                                <gzl:div id="pTypeDec">
                                    <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                        <ui:define name="label">Type</ui:define>
                                        <ui:param name="id" value="pTypeIn"/>
                                        <ui:param name="required" value="true"/>
                                        <h:selectOneMenu value="#{fhirURLValidatorDescriptionEdition.selectedParameter.type}"
                                                         styleClass="form-control  gzl-select-text" id="pTypeIn" required="true">
                                            <f:selectItems value="#{fhirURLValidatorDescriptionEdition.getTypes()}"
                                                           var="entry" label="#{entry.name}" noSelectionLabel="Please select..."/>
                                            <a4j:ajax render="pTypeDec" event="change"/>
                                        </h:selectOneMenu>
                                        <h:outputText value="Regex: #{fhirURLValidatorDescriptionEdition.selectedParameter.type.defaultRegex}"
                                                      rendered="#{not empty fhirURLValidatorDescriptionEdition.selectedParameter.type}"
                                                      styleClass="help-block"/>
                                    </ui:decorate>
                                </gzl:div>
                                <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:define name="label">Regex</ui:define>
                                    <ui:param name="id" value="pRegexIn"/>
                                    <h:inputText id="pRegexIn" styleClass="form-control"
                                                 value="#{fhirURLValidatorDescriptionEdition.selectedParameter.regex}"/>
                                </ui:decorate>
                            </gzl:div>
                            <f:facet name="footer">
                                <a4j:commandButton value="Save changes"
                                                   actionListener="#{fhirURLValidatorDescriptionEdition.saveParameter()}"
                                                   render="displayP"
                                                   styleClass="gzl-btn-green"/>
                            </f:facet>
                        </gri:panel>
                        <rich:dataTable value="#{fhirURLValidatorDescriptionEdition.validatorDescription.requestParameters}" var="parameter"
                                        id="paramTable" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                        render="paramTableDs">
                            <g:column>
                                <ui:define name="header">Name (prefix)</ui:define>
                                <h:outputText value="#{parameter.name}"/>
                                <h:outputText value=" (#{parameter.prefix})" rendered="#{not empty parameter.prefix}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">Type</ui:define>
                                <h:outputText value="#{parameter.type.name}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">Optionality</ui:define>
                                <h:outputText value="Required" rendered="#{parameter.required}"/>
                                <h:outputText value="Optional" rendered="#{not parameter.required}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">Regex</ui:define>
                                <h:outputText value="#{parameter.regex}" rendered="#{not empty parameter.regex}"/>
                                <h:outputText value="#{parameter.type.defaultRegex}" rendered="#{empty parameter.regex}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">Action</ui:define>
                                <a4j:commandLink actionListener="#{fhirURLValidatorDescriptionEdition.setSelectedParameter(parameter)}"
                                                 render="displayP">
                                    <gzl:span styleClass="gzl-icon-pencil"/>
                                </a4j:commandLink>
                                <a4j:commandLink actionListener="#{fhirURLValidatorDescriptionEdition.deleteParameter(parameter)}"
                                    render="paramTable">
                                    <gzl:span styleClass="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="paramTableDs"/>
                                    <ui:param name="dataTableId" value="paramTable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                        <f:facet name="footer">
                            <h:outputLink value="#{fhirURLValidatorDescriptionEdition.backTolist()}">
                                <h:commandButton type="button" value="Back to list"
                                                 styleClass="gzl-btn"/>
                            </h:outputLink>

                            <h:outputLink value="#{fhirURLValidatorDescriptionEdition.backTolist()}">
                                <h:commandButton type="button" value="Cancel"
                                                 styleClass="gzl-btn-orange"/>
                            </h:outputLink>


                            <a4j:commandButton value="Add a parameter"
                                               actionListener="#{fhirURLValidatorDescriptionEdition.addAParameter()}"
                                               render="displayP" rendered="#{not empty fhirURLValidatorDescriptionEdition.validatorDescription.oid}"
                                               styleClass="gzl-btn-blue" immediate="true"/>
                            <h:commandButton value="Save"
                                             action="#{fhirURLValidatorDescriptionEdition.save()}"
                                             styleClass="gzl-btn-green"/>
                        </f:facet>
                    </gri:panel>
                </gzl:div>
            </gzl:div>
        </h:form>
    </ui:define>
</ui:composition>
